<template>
  <q-page padding>
    <q-table
      row-key="id"
      :columns="columns"
      :data="data"
      :filter="filter"
    >
      <template v-slot:top-left>
        <div class="text-h6">
          Locales <q-btn color="primary" icon-right="fas fa-plus-circle" label="Crear" @click="add" />
        </div>
      </template>
      <template v-slot:top-right>
        <q-input borderless debounce="300" v-model="filter" placeholder="Buscar">
          <template v-slot:append>
            <q-icon name="search" />
          </template>
        </q-input>
      </template>
      <template v-slot:body-cell-status="props">
        <td class="text-right">
          <q-badge outline :color="props.row.status | status" :label="props.row.status" />
        </td>
      </template>
      <template v-slot:body-cell-enabled="props">
        <td class="text-right">
          {{ props.row.user.enabled ? 'Sí' : 'No' }}
        </td>
      </template>
      <template v-slot:body-cell-action="props">
        <td>
          <q-btn-group>
            <q-btn color="primary" icon="fas fa-eye" size="0.75em" @click="editCondition(props.row)"/>
            <q-btn color="primary" icon="fas fa-edit" size="0.75em" @click="edit(props.row)" />
            <q-btn color="primary" icon="fas fa-trash-alt" size="0.75em" @click="destroy({ id: props.row._id, index: props.row.__index })" />
          </q-btn-group>
        </td>
      </template>
    </q-table>
    <router-view />
  </q-page>
</template>

<script>
import { mapGetters } from 'vuex'
export default {
  data () {
    return {
      columns: [
        { name: 'email', label: 'Correo', field: row => row.user.username },
        { name: 'name', label: 'Nombre', field: row => row.name },
        { name: 'country', label: 'País', field: row => row.country.name },
        { name: 'city', label: 'Ciudad', field: row => row.city.name },
        { name: 'address', label: 'Dirección', field: row => row.address },
        { name: 'status', label: 'Estatus', field: row => row.status },
        { name: 'enabled', label: 'Habilitada', field: row => row.user.enabled },
        { name: 'action', label: 'Acciones', align: 'center' }
      ],
      filter: null
    }
  },
  mounted () {
    this.getBusiness()
  },
  filters: {
    status (value) {
      switch (value) {
        case 0:
          return 'red'
        case 1:
          return 'orange'
        case 2:
          return 'green'
      }
    }
  },
  computed: {
    ...mapGetters({
      data: 'adminBusiness/all'
    })
  },
  methods: {
    async getBusiness () {
      this.$store.dispatch('adminBusiness/getAll')
    },
    add () {
      this.$router.push({ name: 'admin.business.create' })
    },
    editCondition (business) {
      this.$router.push({ name: 'admin.business.condition', params: { business_id: business._id }, query: { index: business.__index } })
    },
    edit (business) {
      this.$router.push({ name: 'admin.business.edit', params: { business_id: business._id }, query: { index: business.__index } })
    },
    destroy ({ id, index }) {
      this.$q.dialog({
        title: 'Confirmar',
        message: '¿Está seguro de eliminar el registro?',
        cancel: true,
        persistent: true
      }).onOk(async () => {
        let query, color, icon
        try {
          query = await this.$store.dispatch('adminBusiness/destroy', { id, index })
          color = 'info'
          icon = 'sentiment_satisfied'
        } catch (err) {
          query = err
          color = 'negative'
          icon = 'sentiment_dissatisfied'
        }
        const { message } = query
        this.$q.notify({
          position: 'top',
          message,
          color,
          icon
        })
      })
    }
  }
}
</script>
